%P. Kano
%August 24, 2005
%[TruncationError,RoundoffError,EstimatedTotalError] =...
%MWeeksErrorEstimate(Unitmatrix,Trianmatrix,NNodes,NLaguerreCoef,MInversions,SigmaWeeks,BetaWeeks,LagSwitch)

function [TruncationError,RoundoffError,EstimatedTotalError] =...
MWeeksErrorEstimate(Unitmatrix,Trianmatrix,NNodes,NLaguerreCoef,MInversions,SigmaWeeks,BetaWeeks,LagSwitch)

%Compute the Laguerre Coefficients
if(LagSwitch==0)
[ErLaguerreCoef] = MWeeksMidPntLagCoef(Unitmatrix,Trianmatrix,NNodes,2*NLaguerreCoef,2*MInversions,SigmaWeeks,BetaWeeks);
elseif(LagSwitch==1)
[FFTSamples] = MWeeksFFTSample(Unitmatrix,Trianmatrix,NNodes,2*NLaguerreCoef,SigmaWeeks,BetaWeeks);
[ErLaguerreCoef] = MWeeksFFTLagCoef(FFTSamples,NNodes,2*NLaguerreCoef);
clear FFTSamples;
else
[ErLaguerreCoef] = MWeeksMidPntLagCoef(Unitmatrix,Trianmatrix,NNodes,2*NLaguerreCoef,2*MInversions,SigmaWeeks,BetaWeeks);
end

ErLaguerreCoef = abs(ErLaguerreCoef).^2;

TruncationError = sqrt(sum(sum(sum(ErLaguerreCoef(:,:,NLaguerreCoef:1:2*NLaguerreCoef)))));
RoundoffError = (2^(-52))*sqrt(sum(sum(sum(ErLaguerreCoef(:,:,1:1:NLaguerreCoef)))));

EstimatedTotalError = exp(SigmaWeeks)*(TruncationError+RoundoffError);
