%P. Kano
%August 24, 2005

function [EstimatedTotalError] = ...
MWeeksWeidError(SigmaWeeks,BetaMin,BetaMax,DeltaBeta,Unitmatrix,Trianmatrix,NNodes,NLaguerreCoef,MInversions,LagSwitch)

optnew = optimset('TolX',DeltaBeta);
[BetaWeeks,Rinverse,ExitFlag,ExitOutput] = fminbnd('WeeksMinBeta',BetaMin,BetaMax,optnew,SigmaWeeks,Trianmatrix);

%Compute the Laguerre Coefficients
if(LagSwitch==0)
 [LaguerreCoef] = MWeeksMidPntLagCoef(Unitmatrix,Trianmatrix,NNodes,2*NLaguerreCoef,2*MInversions,SigmaWeeks,BetaWeeks);
elseif(LagSwitch==1)
 [FFTSamples] = MWeeksFFTSample(Unitmatrix,Trianmatrix,NNodes,2*NLaguerreCoef,SigmaWeeks,BetaWeeks);
 [LaguerreCoef] = MWeeksFFTLagCoef(FFTSamples,NNodes,2*NLaguerreCoef);
 clear FFTSamples;
else
 [LaguerreCoef] = MWeeksMidPntLagCoef(Unitmatrix,Trianmatrix,NNodes,2*NLaguerreCoef,2*MInversions,SigmaWeeks,BetaWeeks);
end
LaguerreCoef = abs(LaguerreCoef).^2;

TruncationError = sqrt(sum(sum(sum(LaguerreCoef(:,:,NLaguerreCoef:1:2*NLaguerreCoef)))));
RoundoffError = (2^(-52))*sqrt(sum(sum(sum(LaguerreCoef(:,:,1:1:NLaguerreCoef)))));

EstimatedTotalError = exp(SigmaWeeks)*(TruncationError+RoundoffError);
